---
title: Text labels and names
slug: Web/Accessibility/Understanding_WCAG/Text_labels_and_names
tags:
  - Accessibility
  - WCAG
  - text labels
---
<p><span class="seoSummary">There are many situations in which a control, dialog, or other website feature should be given a descriptive name or label to allow users of assistive technologies to understand what its purpose is and how to operate it correctly. </span>There are a number of different types of problems in this category, found in different contexts, and each has its own solution. The different problems and solutions are discussed in the sections below.</p>

<h2 id="Use_alt_attribute_to_label_area_elements_that_have_the_href_attribute">Use alt attribute to label area elements that have the href attribute</h2>

<p>In image maps, give each {{htmlelement("area")}} element an <code>alt</code> attribute containing a name that describes what resources the areas links to. Failure to do so makes an image map hard to use for users of assistive technology — they need alternative text to be able to understand the purpose of an image.</p>

<h3 id="Examples">Examples</h3>

<p>The following example show a simple image map (taken from <a href="https://www.w3.org/TR/WCAG20-TECHS/H24.html">H24: Providing text alternatives for the area elements of image maps</a>):</p>

<pre class="notranslate">&lt;img src="welcome.gif" usemap="#map1"
    alt="Areas in the library. Select an area for
more information on that area." /&gt;
&lt;map id="map1" name="map1"&gt;
  &lt;area shape="rect" coords="0,0,30,30"
    href="reference.html" alt="Reference" /&gt;
  &lt;area shape="rect" coords="34,34,100,100"
    href="media.html" alt="Audio visual lab" /&gt;
&lt;/map&gt;</pre>

<p>See the <a href="/en-US/docs/Web/HTML/Element/area"><code>&lt;area&gt;</code> element reference page</a> for a live interactive example.</p>

<h3 id="See_also">See also</h3>

<ul>
 <li>{{htmlelement("area")}}</li>
 <li><a href="https://www.w3.org/TR/WCAG20-TECHS/H24.html">H24: Providing text alternatives for the area elements of image maps</a></li>
</ul>

<h2 id="Dialogs_should_be_labeled">Dialogs should be labeled</h2>

<p>For any container whose contents act as a dialog box (for example, a modal dialog asking the user to make a choice or respond to an action being taken), give it a descriptive label or name, so that assistive technology users can easily discover what its purpose is.</p>

<p>A dialog box is generally denoted by an ARIA <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/dialog_role">role="dialog"</a></code> or <code><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_alertdialog_role">role="alertdialog"</a></code>; you can use  the <code><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-label_attribute">aria-label</a></code> or <code><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-labelledby_attribute">aria-labelledby</a></code> attributes to provide a label.</p>

<h3 id="Examples_2">Examples</h3>

<p>The following example shows a simple dialog box, defined as such using <code>role="dialog"</code> and labelled using <code>aria-labelledby</code>.</p>

<pre class="notranslate">&lt;div role="dialog" aria-labelledby="dialog1Title" aria-describedby="dialog1Desc"&gt;
  &lt;h2 id="dialog1Title"&gt;Your personal details were successfully updated&lt;/h2&gt;
  &lt;p id="dialog1Desc"&gt;You can change your details at any time in the user account section.&lt;/p&gt;
  &lt;button&gt;Close&lt;/button&gt;
&lt;/div&gt;</pre>

<p>If the dialog box doesn't have a heading, you can instead use <code>aria-label</code> to contain the label text:</p>

<pre class="notranslate">&lt;div role="dialog" aria-label="Personal details updated confirmation"&gt;
  &lt;p&gt;Your personal details were successfully updated. You can
    change your details at any time in the user account section.&lt;/p&gt;
  &lt;button&gt;Close&lt;/button&gt;
&lt;/div&gt;</pre>

<h3 id="See_also_2">See also</h3>

<ul>
 <li><code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/dialog_role">role="dialog"</a></code></li>
 <li><code><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_alertdialog_role">role="alertdialog"</a></code></li>
 <li><code><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-label_attribute">aria-label</a></code></li>
 <li><code><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-labelledby_attribute">aria-labelledby</a></code></li>
 <li><a href="https://www.w3.org/TR/wai-aria-1.2/#dialog">WAI-ARIA: dialog role</a></li>
 <li><a href="https://www.w3.org/TR/wai-aria-practices/#dialog_roles_states_props">Dialog authoring practices</a></li>
</ul>

<h2 id="Documents_must_have_a_title">Documents must have a title</h2>

<p>It is important in each HTML document to include a {{htmlelement("title")}} that describes the page's purpose. A common navigation technique for users of assistive technology is to infer what content a page contains by reading its title. If the title is not available, they have to navigate the page to determine its content, which can be a time consuming and potentially confusing process.</p>

<h3 id="Examples_3">Examples</h3>

<p>The title for the reference article about the {{htmlelement("title")}} element is as follows:</p>

<pre class="notranslate">&lt;title&gt;&amp;lt;title&amp;gt;: The Document Title element - HTML: Hypertext Markup Language | MDN&lt;/title&gt;</pre>

<p>Another example might look like so:</p>

<pre class="notranslate">&lt;title&gt;Fill in your details to register — myGov services&lt;/title&gt;</pre>

<p>To help the user, you can update the page title value to reflect significant page state changes (such as form validation problems):</p>

<pre class="notranslate">&lt;title&gt;2 errors — Fill in your details to register — myGov services&lt;/title&gt;</pre>

<h3 id="See_also_3">See also</h3>

<ul>
 <li>{{htmlelement("title")}}</li>
</ul>

<h2 id="Embedded_content_must_be_labeled">Embedded content must be labeled</h2>

<p>Make sure that elements that embed content have a <a href="/en-US/docs/Web/HTML/Global_attributes/title">title</a> attribute that describes the embedded content. This includes the {{htmlelement("embed")}} and  {{htmlelement("object")}} elements. These elements are often used for graphical content, much like the {{HTMLelement("img")}} element. A descriptive title helps users of assistive technology understand what the element is showing.</p>

<h2 id="Figures_with_optional_captions_should_be_labeled">Figures with optional captions should be labeled</h2>

<p>For best accessibility, include a {{HTMLElement("figcaption")}} within a {{HTMLElement("figure")}} element, even though doing so is technically optional. The caption is in addition to any alternative text on images within the figure. The caption describes the purpose of the figure in the document, which may be different from a simple description of a visual item, as provided by the alternative text.</p>

<h3 id="Example">Example</h3>

<p>The following example shows code for a figure with a caption. The <code>alt</code> attribute of the {{htmlelement("img")}} describes the appearance of the image; the {{htmlelement("figcaption")}} describes it from a functional perspective (in this case, the Latin name of the flower in the image).</p>

<pre class="notranslate">&lt;figure&gt;
  &lt;img src="milkweed.jgp"
      alt="Black and white close-up photo of milkweed flowers"&gt;
 &lt;figcaption&gt;Asclepias verticillata&lt;/figcaption&gt;
&lt;/figure&gt;
</pre>

<h2 id="Fieldset_elements_must_be_labeled">Fieldset elements must be labeled</h2>

<p>Fieldset elements must have a text description, similar to other form elements. Use the {{htmlelement("legend")}} element to describe the purpose of a fieldset.</p>

<h2 id="Use_a_legend_to_label_a_fieldset">Use a legend to label a fieldset</h2>

<p>When grouping a set of form elements together with a {{htmlelement("fieldset")}} element, you should include a nested {{htmlelement("legend")}} element inside it, containing a clear description of the group.</p>

<p>Users of assistive technology find this description helpful when trying to work out the overall purpose of the group. Without the legend, they would have to navigate around the individual form controls in the group to infer an idea of the overall purpose, which could result in confusion.</p>

<h3 id="Examples_4">Examples</h3>

<pre class="notranslate">&lt;form&gt;
  &lt;fieldset&gt;
    &lt;legend&gt;Choose your favorite monster&lt;/legend&gt;

    &lt;input type="radio" id="kraken" name="monster"&gt;
    &lt;label for="kraken"&gt;Kraken&lt;/label&gt;&lt;br/&gt;

    &lt;input type="radio" id="sasquatch" name="monster"&gt;
    &lt;label for="sasquatch"&gt;Sasquatch&lt;/label&gt;&lt;br/&gt;

    &lt;input type="radio" id="mothman" name="monster"&gt;
    &lt;label for="mothman"&gt;Mothman&lt;/label&gt;
  &lt;/fieldset&gt;
&lt;/form&gt;</pre>

<p>You can see a live, interactive version of this example on the <a href="/en-US/docs/Web/HTML/Element/fieldset"><code>&lt;fieldset&gt;</code> reference page</a>.</p>

<h3 id="See_also_4">See also</h3>

<ul>
 <li>{{htmlelement("fieldset")}}</li>
 <li>{{htmlelement("legend")}}</li>
</ul>

<h2 id="Form_elements_must_be_labeled">Form elements must be labeled</h2>

<p>All elements within a form must have a {{htmlelement("label")}} that identifies its purpose. This applies to all types of {{htmlelement("input")}} items, as well as {{htmlelement("button")}}, {{htmlelement("output")}}, {{htmlelement("select")}}, {{htmlelement("textarea")}}, {{htmlelement("progress")}} and {{htmlelement("meter")}} elements, as well as any element with the <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Switch_role"><code>switch</code> ARIA role</a>.</p>

<p>The form element can be placed inside the {{htmlelement("label")}}, in which case the association between the form element and the label is obvious from the structure. Or, you can create an association between a {{htmlelement("label")}} and a form element by specifying the form element's <code>id</code> value as the value of the label's <code>for</code> attribute.</p>

<h3 id="Example_2">Example</h3>

<pre class="notranslate">&lt;label&gt;I agree to the terms and conditions.
  &lt;input type="checkbox" id="terms"&gt;
&lt;/label&gt;

&lt;input type="checkbox" id="emailoptin"&gt;
&lt;label for="emailoptin"&gt;Yes, please send me news about this product.&lt;/label&gt;
</pre>

<h2 id="Form_elements_should_have_a_visible_text_label">Form elements should have a visible text label</h2>

<p>In addition to having a {{htmlelement("label")}} for every form element, those labels should be visible, not hidden. Visible labels help <em>all</em> users understand the purpose of a form element. Do not rely on placeholder text, because it disappears as soon as the user starts typing.</p>

<h2 id="Frame_elements_must_be_labeled">Frame elements must be labeled</h2>

<p>Frame elements, both {{htmlelement("iframe")}} and the older, obsolete {{htmlelement("frame")}}, must have a title to describe the contents of the frame. Use the <code>title</code> attribute to label a frame element. Without a title, users of assistive technologies have to navigate into the frame in order to understand what it contains, which can be difficult and confusing. </p>

<p>The <code>&lt;frame&gt;</code> element is no longer part of the HTML specification as of HTML5. Support for it may be dropped by browsers in the future. In addition, it is difficult for screen readers to navigate pages with <code>&lt;frame&gt;</code> elements. For best accessibility and future maintenance, redesign any pages that use frames to use CSS to achieve a similar layout.</p>

<p>As a best practice, also provide a {{htmlelement("title")}} for the document that is enclosed in the frame, with content identical to the frame's <code>title</code> attribute. (This assumes that the enclosed document is under your control; if not, try to match the frame's <code>title</code> attribute to the document's title.) Some screen readers replace the contents of the <code>title</code> attribute with the contents of the enclosed document's {{htmlelement("title")}}. It's safest and most accessible to provide the same title in both places.</p>

<h3 id="Example_3">Example</h3>

<pre class="notranslate">&lt;iframe
    title="MDN Web docs"
    width="300"
    height="200"
    src="https://developer.mozilla.org"&gt;
&lt;/iframe&gt;

</pre>

<h2 id="Use_alt_attribute_to_label_mglyph_elements">Use alt attribute to label mglyph  elements</h2>

<p>When writing equations with MathML, give each {{mathmlelement("mglyph")}} element an <code>alt</code> attribute containing a name that describes the symbol. Since <code>mglyph</code> elements are used for non-standard symbols without Unicode definitions, screen readers won't automatically be able to name them. Alternative text helps users of screen readers understand the symbol.</p>

<h2 id="Headings_must_be_labeled">Headings must be labeled</h2>

<p>Make sure that your headings have non-empty text content, and are not hidden, such as with CSS <code>display:none</code> or <code>aria-hidden=true</code>. Users of screen readers rely on headings to understand the structure and content of a document.</p>

<p>Also, be sure you are using <a href="/en-US/docs/Web/HTML/Element/Heading_Elements">heading elements</a> only for actual section headings, and not as a shortcut way to make text stand out. Screen reader users typically "skim" a page's headings, much like sighted users; non-heading text that is marked-up with heading elements can cause confusion.</p>

<h2 id="Headings_should_have_visible_text_content">Headings should have visible text content</h2>

<p>Make sure that your headings have non-empty text content, and are not hidden, such as with CSS <code>display:none</code> or <code>aria-hidden=true</code>. Users of screen readers rely on headings to understand the structure and content of a document. Do not use heading elements to mark up images or other graphical content.</p>

<h2 id="Use_title_attribute_to_describe_&lt;iframe&gt;_content">Use title attribute to describe &lt;iframe&gt; content</h2>

<p>Make sure that {{htmlelement("iframe")}} elements have a <code>title</code> attribute to describe the contents of the frame. Without a title, users of assistive technologies have to navigate into the frame in order to understand what it contains, which can be difficult and confusing. </p>

<p>As a best practice, also provide a {{htmlelement("title")}} for the document that is enclosed in the frame, with content identical to the frame's <code>title</code> attribute. (This assumes that the enclosed document is under your control; if not, try to match the frame's <code>title</code> attribute to the document's title.) Some screen readers replace the contents of the <code>title</code> attribute with the contents of the enclosed document's {{htmlelement("title")}}. It's safest and most accessible to provide the same title in both places.</p>

<h2 id="Content_with_images_must_be_labeled">Content with images must be labeled</h2>

<p>Provide descriptive text for all contentful (that is, non-decorative) images and image-like elements. This includes SVG images, {{htmlelement("img")}}, {{htmlelement("canvas")}}, {{htmlelement("map")}}, and {{htmlelement("area")}} elements, as well as {{htmlelement("input")}} elements where <code>type=image</code> and {{htmlelement("object")}} elements where the <code>type</code> starts with <code>image/</code>. The typical way to do this is with the <code>alt</code> attribute. Be sure that the description conveys what is shown in the image.</p>

<h3 id="Example_4">Example</h3>

<pre class="notranslate">&lt;img src="milkweed.jgp"
     alt="Black and white close-up photo of milkweed flowers"&gt; </pre>

<h2 id="Interactive_elements_must_be_labeled">Interactive elements must be labeled</h2>

<p>If an element is intended for users to interact with it, it should have a label. Interactive elements include links ({{htmlelement("a")}}), form elements, buttons, and any element that has a handler for mouse or keyboard events. The way to label an element depends on its type: for form elements, use a {{htmlelement("label")}}; for links, buttons and clickable elements, the text content of the element typically provides the label. If no other option exists for labeling an element, use the <code><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-label_attribute">aria-label</a></code> attribute.</p>

<h2 id="Use_label_attribute_on_optgroup_elements">Use label attribute on optgroup elements</h2>

<p>In an {{htmlelement("optgroup")}} element, use the <code>label</code> attribute to describe the group so that assistive technologies can access it for their users.</p>

<h3 id="Example_5">Example</h3>

<p>In this example, the <code>label</code> attribute on the <code>&lt;optgroup&gt;</code> elements gives a category name for the group of options.</p>

<pre class="notranslate">&lt;label for="dino-select"&gt;Choose a dinosaur:&lt;/label&gt;
&lt;select id="dino-select"&gt;
    &lt;optgroup label="Theropods"&gt;
        &lt;option&gt;Tyrannosaurus&lt;/option&gt;
        &lt;option&gt;Velociraptor&lt;/option&gt;
        &lt;option&gt;Deinonychus&lt;/option&gt;
    &lt;/optgroup&gt;
    &lt;optgroup label="Sauropods"&gt;
        &lt;option&gt;Diplodocus&lt;/option&gt;
        &lt;option&gt;Saltasaurus&lt;/option&gt;
        &lt;option&gt;Apatosaurus&lt;/option&gt;
    &lt;/optgroup&gt;
&lt;/select&gt;</pre>

<h2 id="Toolbars_must_be_labeled_when_there_is_more_than_one_toolbar">Toolbars must be labeled when there is more than one toolbar</h2>

<p>If you define more than one toolbar in a web application using the ARIA <code>toolbar</code> role, you must use the <code><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-label_attribute">aria-label</a></code> attribute to label each one so that it can be described by assistive technology. It is a good practice to label a toolbar, even if there is only one per page.</p>

<h3 id="See_also_5">See also</h3>

<ul>
 <li><a href="https://www.w3.org/TR/wai-aria-practices/examples/toolbar/toolbar.html">W3C ARIA toolbar example</a></li>
</ul>

<h2 id="Related_WCAG_success_criteria">Related WCAG success criteria</h2>

<dl>
 <dt><a href="https://www.w3.org/TR/WCAG21/#non-text-content">1.1.1 Non-text Content (A)</a></dt>
 <dd>All non-text content that is presented to the user has a text alternative that serves the equivalent purpose, except for the situations listed in the above link.</dd>
 <dt><a href="https://www.w3.org/TR/WCAG21/#link-purpose-in-context">2.4.4 Link Purpose (In Context) (A)</a></dt>
 <dd>The purpose of each link can be determined from the link text alone or from the link text together with its programmatically determined link context, except where the purpose of the link would be ambiguous to users in general.</dd>
 <dt><a href="https://www.w3.org/TR/WCAG21/#link-purpose-link-only">2.4.9 Link Purpose (Link Only) (AAA)</a></dt>
 <dd>A mechanism is available to allow the purpose of each link to be identified from link text alone, except where the purpose of the link would be ambiguous to users in general.</dd>
</dl>
